deps.mk 20 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595
  1. # Copyright (c) 2013-2016, Loïc Hoguin <essen@ninenines.eu>
  2. # This file is part of erlang.mk and subject to the terms of the ISC License.
  3. .PHONY: distclean-deps clean-tmp-deps.log
  4. # Configuration.
  5. ifdef OTP_DEPS
  6. $(warning The variable OTP_DEPS is deprecated in favor of LOCAL_DEPS.)
  7. endif
  8. IGNORE_DEPS ?=
  9. export IGNORE_DEPS
  10. APPS_DIR ?= $(CURDIR)/apps
  11. export APPS_DIR
  12. DEPS_DIR ?= $(CURDIR)/deps
  13. export DEPS_DIR
  14. REBAR_DEPS_DIR = $(DEPS_DIR)
  15. export REBAR_DEPS_DIR
  16. dep_name = $(if $(dep_$(1)),$(1),$(if $(pkg_$(1)_name),$(pkg_$(1)_name),$(1)))
  17. dep_repo = $(patsubst git://github.com/%,https://github.com/%, \
  18. $(if $(dep_$(1)),$(word 2,$(dep_$(1))),$(pkg_$(1)_repo)))
  19. dep_commit = $(if $(dep_$(1)_commit),$(dep_$(1)_commit),$(if $(dep_$(1)),$(word 3,$(dep_$(1))),$(pkg_$(1)_commit)))
  20. LOCAL_DEPS_DIRS = $(foreach a,$(LOCAL_DEPS),$(if $(wildcard $(APPS_DIR)/$(a)),$(APPS_DIR)/$(a)))
  21. ALL_APPS_DIRS = $(if $(wildcard $(APPS_DIR)/),$(filter-out $(APPS_DIR),$(shell find $(APPS_DIR) -maxdepth 1 -type d)))
  22. ALL_DEPS_DIRS = $(addprefix $(DEPS_DIR)/,$(foreach dep,$(filter-out $(IGNORE_DEPS),$(BUILD_DEPS) $(DEPS)),$(call dep_name,$(dep))))
  23. ifeq ($(filter $(APPS_DIR) $(DEPS_DIR),$(subst :, ,$(ERL_LIBS))),)
  24. ifeq ($(ERL_LIBS),)
  25. ERL_LIBS = $(APPS_DIR):$(DEPS_DIR)
  26. else
  27. ERL_LIBS := $(ERL_LIBS):$(APPS_DIR):$(DEPS_DIR)
  28. endif
  29. endif
  30. export ERL_LIBS
  31. export NO_AUTOPATCH
  32. # Verbosity.
  33. dep_verbose_0 = @echo " DEP " $(1);
  34. dep_verbose_2 = set -x;
  35. dep_verbose = $(dep_verbose_$(V))
  36. # Core targets.
  37. apps:: $(ALL_APPS_DIRS) clean-tmp-deps.log
  38. ifeq ($(IS_APP)$(IS_DEP),)
  39. $(verbose) rm -f $(ERLANG_MK_TMP)/apps.log
  40. endif
  41. $(verbose) mkdir -p $(ERLANG_MK_TMP)
  42. # Create ebin directory for all apps to make sure Erlang recognizes them
  43. # as proper OTP applications when using -include_lib. This is a temporary
  44. # fix, a proper fix would be to compile apps/* in the right order.
  45. ifndef IS_APP
  46. $(verbose) for dep in $(ALL_APPS_DIRS) ; do \
  47. mkdir -p $$dep/ebin || exit $$?; \
  48. done
  49. endif
  50. # at the toplevel: if LOCAL_DEPS is defined with at least one local app, only
  51. # compile that list of apps. otherwise, compile everything.
  52. # within an app: compile all LOCAL_DEPS that are (uncompiled) local apps
  53. $(verbose) for dep in $(if $(LOCAL_DEPS_DIRS)$(IS_APP),$(LOCAL_DEPS_DIRS),$(ALL_APPS_DIRS)) ; do \
  54. if grep -qs ^$$dep$$ $(ERLANG_MK_TMP)/apps.log; then \
  55. :; \
  56. else \
  57. echo $$dep >> $(ERLANG_MK_TMP)/apps.log; \
  58. $(MAKE) -C $$dep IS_APP=1 || exit $$?; \
  59. fi \
  60. done
  61. clean-tmp-deps.log:
  62. ifeq ($(IS_APP)$(IS_DEP),)
  63. $(verbose) rm -f $(ERLANG_MK_TMP)/deps.log
  64. endif
  65. ifneq ($(SKIP_DEPS),)
  66. deps::
  67. else
  68. deps:: $(ALL_DEPS_DIRS) apps clean-tmp-deps.log
  69. $(verbose) mkdir -p $(ERLANG_MK_TMP)
  70. $(verbose) for dep in $(ALL_DEPS_DIRS) ; do \
  71. if grep -qs ^$$dep$$ $(ERLANG_MK_TMP)/deps.log; then \
  72. :; \
  73. else \
  74. echo $$dep >> $(ERLANG_MK_TMP)/deps.log; \
  75. if [ -f $$dep/GNUmakefile ] || [ -f $$dep/makefile ] || [ -f $$dep/Makefile ]; then \
  76. $(MAKE) -C $$dep IS_DEP=1 || exit $$?; \
  77. else \
  78. echo "Error: No Makefile to build dependency $$dep."; \
  79. exit 2; \
  80. fi \
  81. fi \
  82. done
  83. endif
  84. # Deps related targets.
  85. # @todo rename GNUmakefile and makefile into Makefile first, if they exist
  86. # While Makefile file could be GNUmakefile or makefile,
  87. # in practice only Makefile is needed so far.
  88. define dep_autopatch
  89. if [ -f $(DEPS_DIR)/$(1)/erlang.mk ]; then \
  90. rm -rf $(DEPS_DIR)/$1/ebin/; \
  91. $(call erlang,$(call dep_autopatch_appsrc.erl,$(1))); \
  92. $(call dep_autopatch_erlang_mk,$(1)); \
  93. elif [ -f $(DEPS_DIR)/$(1)/Makefile ]; then \
  94. if [ -f $(DEPS_DIR)/$1/rebar.lock ]; then \
  95. $(call dep_autopatch2,$1); \
  96. elif [ 0 != `grep -c "include ../\w*\.mk" $(DEPS_DIR)/$(1)/Makefile` ]; then \
  97. $(call dep_autopatch2,$(1)); \
  98. elif [ 0 != `grep -ci "^[^#].*rebar" $(DEPS_DIR)/$(1)/Makefile` ]; then \
  99. $(call dep_autopatch2,$(1)); \
  100. elif [ -n "`find $(DEPS_DIR)/$(1)/ -type f -name \*.mk -not -name erlang.mk -exec grep -i "^[^#].*rebar" '{}' \;`" ]; then \
  101. $(call dep_autopatch2,$(1)); \
  102. fi \
  103. else \
  104. if [ ! -d $(DEPS_DIR)/$(1)/src/ ]; then \
  105. $(call dep_autopatch_noop,$(1)); \
  106. else \
  107. $(call dep_autopatch2,$(1)); \
  108. fi \
  109. fi
  110. endef
  111. define dep_autopatch2
  112. mv -n $(DEPS_DIR)/$1/ebin/$1.app $(DEPS_DIR)/$1/src/$1.app.src; \
  113. rm -f $(DEPS_DIR)/$1/ebin/$1.app; \
  114. if [ -f $(DEPS_DIR)/$1/src/$1.app.src.script ]; then \
  115. $(call erlang,$(call dep_autopatch_appsrc_script.erl,$(1))); \
  116. fi; \
  117. $(call erlang,$(call dep_autopatch_appsrc.erl,$(1))); \
  118. if [ -f $(DEPS_DIR)/$(1)/rebar -o -f $(DEPS_DIR)/$(1)/rebar.config -o -f $(DEPS_DIR)/$(1)/rebar.config.script -o -f $(DEPS_DIR)/$1/rebar.lock ]; then \
  119. $(call dep_autopatch_fetch_rebar); \
  120. $(call dep_autopatch_rebar,$(1)); \
  121. else \
  122. $(call dep_autopatch_gen,$(1)); \
  123. fi
  124. endef
  125. define dep_autopatch_noop
  126. printf "noop:\n" > $(DEPS_DIR)/$(1)/Makefile
  127. endef
  128. # Overwrite erlang.mk with the current file by default.
  129. ifeq ($(NO_AUTOPATCH_ERLANG_MK),)
  130. define dep_autopatch_erlang_mk
  131. echo "include $(call core_relpath,$(dir $(ERLANG_MK_FILENAME)),$(DEPS_DIR)/app)/erlang.mk" \
  132. > $(DEPS_DIR)/$1/erlang.mk
  133. endef
  134. else
  135. define dep_autopatch_erlang_mk
  136. :
  137. endef
  138. endif
  139. define dep_autopatch_gen
  140. printf "%s\n" \
  141. "ERLC_OPTS = +debug_info" \
  142. "include ../../erlang.mk" > $(DEPS_DIR)/$(1)/Makefile
  143. endef
  144. define dep_autopatch_fetch_rebar
  145. mkdir -p $(ERLANG_MK_TMP); \
  146. if [ ! -d $(ERLANG_MK_TMP)/rebar ]; then \
  147. git clone -q -n -- https://github.com/rebar/rebar $(ERLANG_MK_TMP)/rebar; \
  148. cd $(ERLANG_MK_TMP)/rebar; \
  149. git checkout -q 576e12171ab8d69b048b827b92aa65d067deea01; \
  150. $(MAKE); \
  151. cd -; \
  152. fi
  153. endef
  154. define dep_autopatch_rebar
  155. if [ -f $(DEPS_DIR)/$(1)/Makefile ]; then \
  156. mv $(DEPS_DIR)/$(1)/Makefile $(DEPS_DIR)/$(1)/Makefile.orig.mk; \
  157. fi; \
  158. $(call erlang,$(call dep_autopatch_rebar.erl,$(1))); \
  159. rm -f $(DEPS_DIR)/$(1)/ebin/$(1).app
  160. endef
  161. define dep_autopatch_rebar.erl
  162. application:load(rebar),
  163. application:set_env(rebar, log_level, debug),
  164. rmemo:start(),
  165. Conf1 = case file:consult("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config)") of
  166. {ok, Conf0} -> Conf0;
  167. _ -> []
  168. end,
  169. {Conf, OsEnv} = fun() ->
  170. case filelib:is_file("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)") of
  171. false -> {Conf1, []};
  172. true ->
  173. Bindings0 = erl_eval:new_bindings(),
  174. Bindings1 = erl_eval:add_binding('CONFIG', Conf1, Bindings0),
  175. Bindings = erl_eval:add_binding('SCRIPT', "$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)", Bindings1),
  176. Before = os:getenv(),
  177. {ok, Conf2} = file:script("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)", Bindings),
  178. {Conf2, lists:foldl(fun(E, Acc) -> lists:delete(E, Acc) end, os:getenv(), Before)}
  179. end
  180. end(),
  181. Write = fun (Text) ->
  182. file:write_file("$(call core_native_path,$(DEPS_DIR)/$1/Makefile)", Text, [append])
  183. end,
  184. Escape = fun (Text) ->
  185. re:replace(Text, "\\\\$$", "\$$$$", [global, {return, list}])
  186. end,
  187. Write("IGNORE_DEPS += edown eper eunit_formatters meck node_package "
  188. "rebar_lock_deps_plugin rebar_vsn_plugin reltool_util\n"),
  189. Write("C_SRC_DIR = /path/do/not/exist\n"),
  190. Write("C_SRC_TYPE = rebar\n"),
  191. Write("DRV_CFLAGS = -fPIC\nexport DRV_CFLAGS\n"),
  192. Write(["ERLANG_ARCH = ", rebar_utils:wordsize(), "\nexport ERLANG_ARCH\n"]),
  193. fun() ->
  194. Write("ERLC_OPTS = +debug_info\nexport ERLC_OPTS\n"),
  195. case lists:keyfind(erl_opts, 1, Conf) of
  196. false -> ok;
  197. {_, ErlOpts} ->
  198. lists:foreach(fun
  199. ({d, D}) ->
  200. Write("ERLC_OPTS += -D" ++ atom_to_list(D) ++ "=1\n");
  201. ({i, I}) ->
  202. Write(["ERLC_OPTS += -I ", I, "\n"]);
  203. ({platform_define, Regex, D}) ->
  204. case rebar_utils:is_arch(Regex) of
  205. true -> Write("ERLC_OPTS += -D" ++ atom_to_list(D) ++ "=1\n");
  206. false -> ok
  207. end;
  208. ({parse_transform, PT}) ->
  209. Write("ERLC_OPTS += +'{parse_transform, " ++ atom_to_list(PT) ++ "}'\n");
  210. (_) -> ok
  211. end, ErlOpts)
  212. end,
  213. Write("\n")
  214. end(),
  215. fun() ->
  216. File = case lists:keyfind(deps, 1, Conf) of
  217. false -> [];
  218. {_, Deps} ->
  219. [begin case case Dep of
  220. {N, S} when is_atom(N), is_list(S) -> {N, {hex, S}};
  221. {N, S} when is_tuple(S) -> {N, S};
  222. {N, _, S} -> {N, S};
  223. {N, _, S, _} -> {N, S};
  224. _ -> false
  225. end of
  226. false -> ok;
  227. {Name, Source} ->
  228. {Method, Repo, Commit} = case Source of
  229. {hex, V} -> {hex, V, undefined};
  230. {git, R} -> {git, R, master};
  231. {M, R, {branch, C}} -> {M, R, C};
  232. {M, R, {ref, C}} -> {M, R, C};
  233. {M, R, {tag, C}} -> {M, R, C};
  234. {M, R, C} -> {M, R, C}
  235. end,
  236. Write(io_lib:format("DEPS += ~s\ndep_~s = ~s ~s ~s~n", [Name, Name, Method, Repo, Commit]))
  237. end end || Dep <- Deps]
  238. end
  239. end(),
  240. fun() ->
  241. case lists:keyfind(erl_first_files, 1, Conf) of
  242. false -> ok;
  243. {_, Files} ->
  244. Names = [[" ", case lists:reverse(F) of
  245. "lre." ++ Elif -> lists:reverse(Elif);
  246. Elif -> lists:reverse(Elif)
  247. end] || "src/" ++ F <- Files],
  248. Write(io_lib:format("COMPILE_FIRST +=~s\n", [Names]))
  249. end
  250. end(),
  251. Write("\n\nrebar_dep: preprocess pre-deps deps pre-app app\n"),
  252. Write("\npreprocess::\n"),
  253. Write("\npre-deps::\n"),
  254. Write("\npre-app::\n"),
  255. PatchHook = fun(Cmd) ->
  256. case Cmd of
  257. "make -C" ++ Cmd1 -> "$$\(MAKE) -C" ++ Escape(Cmd1);
  258. "gmake -C" ++ Cmd1 -> "$$\(MAKE) -C" ++ Escape(Cmd1);
  259. "make " ++ Cmd1 -> "$$\(MAKE) -f Makefile.orig.mk " ++ Escape(Cmd1);
  260. "gmake " ++ Cmd1 -> "$$\(MAKE) -f Makefile.orig.mk " ++ Escape(Cmd1);
  261. _ -> Escape(Cmd)
  262. end
  263. end,
  264. fun() ->
  265. case lists:keyfind(pre_hooks, 1, Conf) of
  266. false -> ok;
  267. {_, Hooks} ->
  268. [case H of
  269. {'get-deps', Cmd} ->
  270. Write("\npre-deps::\n\t" ++ PatchHook(Cmd) ++ "\n");
  271. {compile, Cmd} ->
  272. Write("\npre-app::\n\tCC=$$\(CC) " ++ PatchHook(Cmd) ++ "\n");
  273. {Regex, compile, Cmd} ->
  274. case rebar_utils:is_arch(Regex) of
  275. true -> Write("\npre-app::\n\tCC=$$\(CC) " ++ PatchHook(Cmd) ++ "\n");
  276. false -> ok
  277. end;
  278. _ -> ok
  279. end || H <- Hooks]
  280. end
  281. end(),
  282. ShellToMk = fun(V) ->
  283. re:replace(re:replace(V, "(\\\\$$)(\\\\w*)", "\\\\1(\\\\2)", [global]),
  284. "-Werror\\\\b", "", [{return, list}, global])
  285. end,
  286. PortSpecs = fun() ->
  287. case lists:keyfind(port_specs, 1, Conf) of
  288. false ->
  289. case filelib:is_dir("$(call core_native_path,$(DEPS_DIR)/$1/c_src)") of
  290. false -> [];
  291. true ->
  292. [{"priv/" ++ proplists:get_value(so_name, Conf, "$(1)_drv.so"),
  293. proplists:get_value(port_sources, Conf, ["c_src/*.c"]), []}]
  294. end;
  295. {_, Specs} ->
  296. lists:flatten([case S of
  297. {Output, Input} -> {ShellToMk(Output), Input, []};
  298. {Regex, Output, Input} ->
  299. case rebar_utils:is_arch(Regex) of
  300. true -> {ShellToMk(Output), Input, []};
  301. false -> []
  302. end;
  303. {Regex, Output, Input, [{env, Env}]} ->
  304. case rebar_utils:is_arch(Regex) of
  305. true -> {ShellToMk(Output), Input, Env};
  306. false -> []
  307. end
  308. end || S <- Specs])
  309. end
  310. end(),
  311. PortSpecWrite = fun (Text) ->
  312. file:write_file("$(call core_native_path,$(DEPS_DIR)/$1/c_src/Makefile.erlang.mk)", Text, [append])
  313. end,
  314. case PortSpecs of
  315. [] -> ok;
  316. _ ->
  317. Write("\npre-app::\n\t$$\(MAKE) -f c_src/Makefile.erlang.mk\n"),
  318. PortSpecWrite(io_lib:format("ERL_CFLAGS ?= -finline-functions -Wall -fPIC -I \\"~s/erts-~s/include\\" -I \\"~s\\"\n",
  319. [code:root_dir(), erlang:system_info(version), code:lib_dir(erl_interface, include)])),
  320. PortSpecWrite(io_lib:format("ERL_LDFLAGS ?= -L \\"~s\\" -lerl_interface -lei\n",
  321. [code:lib_dir(erl_interface, lib)])),
  322. [PortSpecWrite(["\n", E, "\n"]) || E <- OsEnv],
  323. FilterEnv = fun(Env) ->
  324. lists:flatten([case E of
  325. {_, _} -> E;
  326. {Regex, K, V} ->
  327. case rebar_utils:is_arch(Regex) of
  328. true -> {K, V};
  329. false -> []
  330. end
  331. end || E <- Env])
  332. end,
  333. MergeEnv = fun(Env) ->
  334. lists:foldl(fun ({K, V}, Acc) ->
  335. case lists:keyfind(K, 1, Acc) of
  336. false -> [{K, rebar_utils:expand_env_variable(V, K, "")}|Acc];
  337. {_, V0} -> [{K, rebar_utils:expand_env_variable(V, K, V0)}|Acc]
  338. end
  339. end, [], Env)
  340. end,
  341. PortEnv = case lists:keyfind(port_env, 1, Conf) of
  342. false -> [];
  343. {_, PortEnv0} -> FilterEnv(PortEnv0)
  344. end,
  345. PortSpec = fun ({Output, Input0, Env}) ->
  346. filelib:ensure_dir("$(call core_native_path,$(DEPS_DIR)/$1/)" ++ Output),
  347. Input = [[" ", I] || I <- Input0],
  348. PortSpecWrite([
  349. [["\n", K, " = ", ShellToMk(V)] || {K, V} <- lists:reverse(MergeEnv(PortEnv))],
  350. case $(PLATFORM) of
  351. darwin -> "\n\nLDFLAGS += -flat_namespace -undefined suppress";
  352. _ -> ""
  353. end,
  354. "\n\nall:: ", Output, "\n\n",
  355. "%.o: %.c\n\t$$\(CC) -c -o $$\@ $$\< $$\(CFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  356. "%.o: %.C\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  357. "%.o: %.cc\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  358. "%.o: %.cpp\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  359. [[Output, ": ", K, " += ", ShellToMk(V), "\n"] || {K, V} <- lists:reverse(MergeEnv(FilterEnv(Env)))],
  360. Output, ": $$\(foreach ext,.c .C .cc .cpp,",
  361. "$$\(patsubst %$$\(ext),%.o,$$\(filter %$$\(ext),$$\(wildcard", Input, "))))\n",
  362. "\t$$\(CC) -o $$\@ $$\? $$\(LDFLAGS) $$\(ERL_LDFLAGS) $$\(DRV_LDFLAGS) $$\(EXE_LDFLAGS)",
  363. case {filename:extension(Output), $(PLATFORM)} of
  364. {[], _} -> "\n";
  365. {_, darwin} -> "\n";
  366. _ -> " -shared\n"
  367. end])
  368. end,
  369. [PortSpec(S) || S <- PortSpecs]
  370. end,
  371. Write("\ninclude $(call core_relpath,$(dir $(ERLANG_MK_FILENAME)),$(DEPS_DIR)/app)/erlang.mk"),
  372. RunPlugin = fun(Plugin, Step) ->
  373. case erlang:function_exported(Plugin, Step, 2) of
  374. false -> ok;
  375. true ->
  376. c:cd("$(call core_native_path,$(DEPS_DIR)/$1/)"),
  377. Ret = Plugin:Step({config, "", Conf, dict:new(), dict:new(), dict:new(),
  378. dict:store(base_dir, "", dict:new())}, undefined),
  379. io:format("rebar plugin ~p step ~p ret ~p~n", [Plugin, Step, Ret])
  380. end
  381. end,
  382. fun() ->
  383. case lists:keyfind(plugins, 1, Conf) of
  384. false -> ok;
  385. {_, Plugins} ->
  386. [begin
  387. case lists:keyfind(deps, 1, Conf) of
  388. false -> ok;
  389. {_, Deps} ->
  390. case lists:keyfind(P, 1, Deps) of
  391. false -> ok;
  392. _ ->
  393. Path = "$(call core_native_path,$(DEPS_DIR)/)" ++ atom_to_list(P),
  394. io:format("~s", [os:cmd("$(MAKE) -C $(call core_native_path,$(DEPS_DIR)/$1) " ++ Path)]),
  395. io:format("~s", [os:cmd("$(MAKE) -C " ++ Path ++ " IS_DEP=1")]),
  396. code:add_patha(Path ++ "/ebin")
  397. end
  398. end
  399. end || P <- Plugins],
  400. [case code:load_file(P) of
  401. {module, P} -> ok;
  402. _ ->
  403. case lists:keyfind(plugin_dir, 1, Conf) of
  404. false -> ok;
  405. {_, PluginsDir} ->
  406. ErlFile = "$(call core_native_path,$(DEPS_DIR)/$1/)" ++ PluginsDir ++ "/" ++ atom_to_list(P) ++ ".erl",
  407. {ok, P, Bin} = compile:file(ErlFile, [binary]),
  408. {module, P} = code:load_binary(P, ErlFile, Bin)
  409. end
  410. end || P <- Plugins],
  411. [RunPlugin(P, preprocess) || P <- Plugins],
  412. [RunPlugin(P, pre_compile) || P <- Plugins],
  413. [RunPlugin(P, compile) || P <- Plugins]
  414. end
  415. end(),
  416. halt()
  417. endef
  418. define dep_autopatch_appsrc_script.erl
  419. AppSrc = "$(call core_native_path,$(DEPS_DIR)/$1/src/$1.app.src)",
  420. AppSrcScript = AppSrc ++ ".script",
  421. Bindings = erl_eval:new_bindings(),
  422. {ok, Conf} = file:script(AppSrcScript, Bindings),
  423. ok = file:write_file(AppSrc, io_lib:format("~p.~n", [Conf])),
  424. halt()
  425. endef
  426. define dep_autopatch_appsrc.erl
  427. AppSrcOut = "$(call core_native_path,$(DEPS_DIR)/$1/src/$1.app.src)",
  428. AppSrcIn = case filelib:is_regular(AppSrcOut) of false -> "$(call core_native_path,$(DEPS_DIR)/$1/ebin/$1.app)"; true -> AppSrcOut end,
  429. case filelib:is_regular(AppSrcIn) of
  430. false -> ok;
  431. true ->
  432. {ok, [{application, $(1), L0}]} = file:consult(AppSrcIn),
  433. L1 = lists:keystore(modules, 1, L0, {modules, []}),
  434. L2 = case lists:keyfind(vsn, 1, L1) of {_, git} -> lists:keyreplace(vsn, 1, L1, {vsn, "git"}); _ -> L1 end,
  435. L3 = case lists:keyfind(registered, 1, L2) of false -> [{registered, []}|L2]; _ -> L2 end,
  436. ok = file:write_file(AppSrcOut, io_lib:format("~p.~n", [{application, $(1), L3}])),
  437. case AppSrcOut of AppSrcIn -> ok; _ -> ok = file:delete(AppSrcIn) end
  438. end,
  439. halt()
  440. endef
  441. define dep_fetch_git
  442. git clone -q -n -- $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1)); \
  443. cd $(DEPS_DIR)/$(call dep_name,$(1)) && git checkout -q $(call dep_commit,$(1));
  444. endef
  445. define dep_fetch_git-submodule
  446. git submodule update --init -- $(DEPS_DIR)/$1;
  447. endef
  448. define dep_fetch_hg
  449. hg clone -q -U $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1)); \
  450. cd $(DEPS_DIR)/$(call dep_name,$(1)) && hg update -q $(call dep_commit,$(1));
  451. endef
  452. define dep_fetch_svn
  453. svn checkout -q $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1));
  454. endef
  455. define dep_fetch_cp
  456. cp -R $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1));
  457. endef
  458. # Hex only has a package version. No need to look in the Erlang.mk packages.
  459. define dep_fetch_hex
  460. mkdir -p $(ERLANG_MK_TMP)/hex $(DEPS_DIR)/$1; \
  461. $(call core_http_get,$(ERLANG_MK_TMP)/hex/$1.tar,\
  462. https://s3.amazonaws.com/s3.hex.pm/tarballs/$1-$(strip $(word 2,$(dep_$1))).tar); \
  463. tar -xOf $(ERLANG_MK_TMP)/hex/$1.tar contents.tar.gz | tar -C $(DEPS_DIR)/$1 -xzf -;
  464. endef
  465. define dep_fetch_fail
  466. echo "Error: Unknown or invalid dependency: $(1)." >&2; \
  467. exit 78;
  468. endef
  469. # Kept for compatibility purposes with older Erlang.mk configuration.
  470. define dep_fetch_legacy
  471. $(warning WARNING: '$(1)' dependency configuration uses deprecated format.) \
  472. git clone -q -n -- $(word 1,$(dep_$(1))) $(DEPS_DIR)/$(1); \
  473. cd $(DEPS_DIR)/$(1) && git checkout -q $(if $(word 2,$(dep_$(1))),$(word 2,$(dep_$(1))),master);
  474. endef
  475. define dep_fetch
  476. $(if $(dep_$(1)), \
  477. $(if $(dep_fetch_$(word 1,$(dep_$(1)))), \
  478. $(word 1,$(dep_$(1))), \
  479. $(if $(IS_DEP),legacy,fail)), \
  480. $(if $(filter $(1),$(PACKAGES)), \
  481. $(pkg_$(1)_fetch), \
  482. fail))
  483. endef
  484. define dep_target
  485. $(DEPS_DIR)/$(call dep_name,$1):
  486. $(eval DEP_NAME := $(call dep_name,$1))
  487. $(eval DEP_STR := $(if $(filter-out $1,$(DEP_NAME)),$1,"$1 ($(DEP_NAME))"))
  488. $(verbose) if test -d $(APPS_DIR)/$(DEP_NAME); then \
  489. echo "Error: Dependency" $(DEP_STR) "conflicts with application found in $(APPS_DIR)/$(DEP_NAME)."; \
  490. exit 17; \
  491. fi
  492. $(verbose) mkdir -p $(DEPS_DIR)
  493. $(dep_verbose) $(call dep_fetch_$(strip $(call dep_fetch,$(1))),$(1))
  494. $(verbose) if [ -f $(DEPS_DIR)/$(1)/configure.ac -o -f $(DEPS_DIR)/$(1)/configure.in ] \
  495. && [ ! -f $(DEPS_DIR)/$(1)/configure ]; then \
  496. echo " AUTO " $(1); \
  497. cd $(DEPS_DIR)/$(1) && autoreconf -Wall -vif -I m4; \
  498. fi
  499. - $(verbose) if [ -f $(DEPS_DIR)/$(DEP_NAME)/configure ]; then \
  500. echo " CONF " $(DEP_STR); \
  501. cd $(DEPS_DIR)/$(DEP_NAME) && ./configure; \
  502. fi
  503. ifeq ($(filter $(1),$(NO_AUTOPATCH)),)
  504. $(verbose) if [ "$(1)" = "amqp_client" -a "$(RABBITMQ_CLIENT_PATCH)" ]; then \
  505. if [ ! -d $(DEPS_DIR)/rabbitmq-codegen ]; then \
  506. echo " PATCH Downloading rabbitmq-codegen"; \
  507. git clone https://github.com/rabbitmq/rabbitmq-codegen.git $(DEPS_DIR)/rabbitmq-codegen; \
  508. fi; \
  509. if [ ! -d $(DEPS_DIR)/rabbitmq-server ]; then \
  510. echo " PATCH Downloading rabbitmq-server"; \
  511. git clone https://github.com/rabbitmq/rabbitmq-server.git $(DEPS_DIR)/rabbitmq-server; \
  512. fi; \
  513. ln -s $(DEPS_DIR)/amqp_client/deps/rabbit_common-0.0.0 $(DEPS_DIR)/rabbit_common; \
  514. elif [ "$(1)" = "rabbit" -a "$(RABBITMQ_SERVER_PATCH)" ]; then \
  515. if [ ! -d $(DEPS_DIR)/rabbitmq-codegen ]; then \
  516. echo " PATCH Downloading rabbitmq-codegen"; \
  517. git clone https://github.com/rabbitmq/rabbitmq-codegen.git $(DEPS_DIR)/rabbitmq-codegen; \
  518. fi \
  519. else \
  520. $$(call dep_autopatch,$(DEP_NAME)) \
  521. fi
  522. endif
  523. endef
  524. $(foreach dep,$(BUILD_DEPS) $(DEPS),$(eval $(call dep_target,$(dep))))
  525. ifndef IS_APP
  526. clean:: clean-apps
  527. clean-apps:
  528. $(verbose) for dep in $(ALL_APPS_DIRS) ; do \
  529. $(MAKE) -C $$dep clean IS_APP=1 || exit $$?; \
  530. done
  531. distclean:: distclean-apps
  532. distclean-apps:
  533. $(verbose) for dep in $(ALL_APPS_DIRS) ; do \
  534. $(MAKE) -C $$dep distclean IS_APP=1 || exit $$?; \
  535. done
  536. endif
  537. ifndef SKIP_DEPS
  538. distclean:: distclean-deps
  539. distclean-deps:
  540. $(gen_verbose) rm -rf $(DEPS_DIR)
  541. endif
  542. # Forward-declare variables used in core/deps-tools.mk. This is required
  543. # in case plugins use them.
  544. ERLANG_MK_RECURSIVE_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-deps-list.log
  545. ERLANG_MK_RECURSIVE_DOC_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-doc-deps-list.log
  546. ERLANG_MK_RECURSIVE_REL_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-rel-deps-list.log
  547. ERLANG_MK_RECURSIVE_TEST_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-test-deps-list.log
  548. ERLANG_MK_RECURSIVE_SHELL_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-shell-deps-list.log